#!/usr/bin/env node
"use strict";

require("source-map-support/register");

var _startupCheck = _interopRequireDefault(require("./utils/startupCheck"));

var _setupEnv = _interopRequireDefault(require("./utils/setupEnv"));

var logger = _interopRequireWildcard(require("./utils/logger"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// Makes the script crash on unhandled rejections instead of silently
// ignoring them. In the future, promise rejections that are not handled will
// terminate the Node.js process with a non-zero exit code.
// See https://github.com/facebook/create-react-app/blob/f36d61a/packages/react-scripts/bin/react-scripts.js#L11-L16
process.on('unhandledRejection', err => {
  throw err;
});

async function startUp(env) {
  await (0, _setupEnv.default)(env);
  await (0, _startupCheck.default)();
}

void (async () => {
  switch (process.argv[1]) {
    // "build" is the only task which runs with NODE_ENV "production"
    case 'build':
      {
        await startUp('production');
        break;
      }

    default:
      {
        await startUp('development');
      }
  }

  const {
    program
  } = await Promise.resolve().then(() => _interopRequireWildcard(require('./program')));
  return program.parseAsync(process.argv);
})().catch(err => {
  logger.error(err.message);

  if (err.stack) {
    logger.debug(err.stack);
  }

  process.exit(err.exitCode || process.exitCode || 1);
});
//# sourceMappingURL=cli.js.map