"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var fs = _interopRequireWildcard(require("fs-extra"));

var _core = _interopRequireDefault(require("@svgr/core"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// @ts-ignore
function createPlugin() {
  const plugin = {
    name: 'svgr',

    setup(build) {
      build.onResolve({
        filter: /@svgr:.*/
      }, args => {
        const pathName = _path.default.join(args.resolveDir, args.path.slice('@svgr:'.length));

        return {
          path: pathName,
          namespace: 'svgr'
        };
      });
      build.onLoad({
        filter: /.*/,
        namespace: 'svgr'
      }, async args => {
        const contents = await (0, _core.default)(await fs.readFile(args.path, 'utf8'));
        return {
          contents,
          resolveDir: _path.default.dirname(args.path),
          loader: 'jsx'
        };
      });
      build.onResolve({
        filter: /@svgurl:.*/
      }, args => {
        const pathName = _path.default.join(args.resolveDir, args.path.slice('@svgurl:'.length));

        return {
          path: pathName,
          namespace: 'svgurl'
        };
      });
      build.onLoad({
        filter: /.*/,
        namespace: 'svgurl'
      }, async args => {
        const contents = await fs.readFile(args.path, 'utf8');
        return {
          contents,
          loader: 'file'
        };
      });
      build.onResolve({
        filter: /\.svg$/,
        namespace: 'file'
      }, args => {
        const pathName = _path.default.join(args.resolveDir, args.path);

        if (args.kind === 'url-token') {
          return {
            path: pathName,
            namespace: 'modular-svgurl'
          };
        } else {
          return {
            path: pathName,
            namespace: 'modular-svgr'
          };
        }
      });
      build.onLoad({
        filter: /\.svg$/,
        namespace: 'modular-svgurl'
      }, async args => {
        const contents = await fs.readFile(args.path, 'utf8');
        return {
          contents,
          loader: 'dataurl'
        };
      });
      build.onLoad({
        filter: /\.svg$/,
        namespace: 'modular-svgr'
      }, args => {
        const resolveDir = _path.default.dirname(args.path);

        const relativePath = _path.default.relative(resolveDir, args.path);

        return {
          resolveDir,
          contents: `
                        export { default } from "@svgurl:${relativePath}";
                        export { default as ReactComponent } from "@svgr:${relativePath}";
                    `,
          loader: 'jsx'
        };
      });
    }

  };
  return plugin;
}

var _default = createPlugin;
exports.default = _default;
//# sourceMappingURL=svgr.js.map