"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatError = formatError;

var _chalk = _interopRequireDefault(require("chalk"));

var fs = _interopRequireWildcard(require("fs-extra"));

var _babelCodeFrame = _interopRequireDefault(require("babel-code-frame"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function formatError(error) {
  var _error$location;

  if ((_error$location = error.location) !== null && _error$location !== void 0 && _error$location.file) {
    const source = await fs.readFile(error.location.file, {
      encoding: 'utf-8'
    });
    return `${_chalk.default.red('Error:')}[${error.location.file}] ${error.text}
  
${(0, _babelCodeFrame.default)(source, error.location.line, error.location.column, {
      linesAbove: 1,
      linesBelow: 1,
      highlightCode: true
    })}
    `;
  } else {
    return `This is a bad error ... lol\n`;
  }
}
//# sourceMappingURL=formatError.js.map